' *!* make sure you build this example with the "Build GUI App" option turned off

Strict
Framework BRL.Blitz
Import BRL.StandardIO

Rem
This Tutorial shows how To do 2d Graphics with the Irrlicht Engine.
It shows how To draw images, keycolor based sprites,
transparent rectangles And different fonts. You will may consider
this useful If you want To make a 2d game with the engine, Or If 
you want To draw a cool interface Or head up display For your 3d game.

As always, import the Irrlicht module
EndRem

Import gg.IrrBMAX

Rem
At first, we let the user Select the driver Type, Then 
start up the engine, set a caption, And get a pointer
To the video driver.
EndRem

' let user Select driver Type

Local driverType:Int=EDT_NULL
Local strInput:String=""

strInput$= ..
	Input("Please select the driver you want for this example:"+Chr(13)+Chr(10)+ ..
	" (a) Direct3D 9.0c"+Chr(13)+Chr(10)+ ..
	" (b) Direct3D 8.1"+Chr(13)+Chr(10)+ ..
	" (c) OpenGL 1.2"+Chr(13)+Chr(10)+ ..
	" (d) Software Renderer"+Chr(13)+Chr(10)+ ..
	" (e) Apfelbaum Software Renderer"+Chr(13)+Chr(10)+ ..
	" (f) NullDevice"+Chr(13)+Chr(10)+ ..
	" (otherKey) Exit"+Chr(13)+Chr(10)+Chr(13)+Chr(10))

Select strInput$
	Case "a"
		driverType=EDT_DIRECT3D9
	Case "b"
		driverType=EDT_DIRECT3D8
	Case "c"
		driverType=EDT_OPENGL
	Case "d"
		driverType=EDT_SOFTWARE
	Case "e"
		driverType=EDT_SOFTWARE2
	Case "f"
		driverType=EDT_NULL
	Default
		Return 
EndSelect

' create device

Local device:T_irrIrrlichtDevice= ..
	T_irrIrrlichtDevice.create(driverType,T_irrDimension2d_s32.create(512,384))

If device.handle=0 Then Return ' could Not create selected driver.

device.setWindowCaption("Irrlicht Engine - 2D Graphics Demo")

Local driver:T_irrIVideoDriver=device.getVideoDriver()

Rem
	All 2d Graphics in this example are put together into one texture,
	2ddemo.bmp. Because we want To draw colorkey based sprites, we need 
	To load this texture And tell the engine, which
	part of it should be transparent based on a colorkey. In this example,
	we don't tell it the color directly, we just say "Hey Irrlicht Engine, 
	you'll find the color I want at position (0,0) on the texture.".
	Instead, it would be also possible To call 
	driver.makeColorKeyTexture(images, T_irrSColor.createFromVals(0,0,0,0)), To make
	e.g. all black pixels transparent. Please note, that makeColorKeyTexture
	just creates an alpha channel based on the color. 
EndRem

Local images:T_irrITexture=driver.getTexture("../media/2ddemo.bmp")
driver.makeColorKeyTextureFromPixel(images,T_irrPosition2d_s32.create(0,0))
	
Rem
	To be able To draw some text with two different fonts, we load them.
	Ok, we load just one, as first font we just use the Default font which is
	built into the engine.
	Also, we define two rectangles, which specify the position of the
	images of the red imps (little flying creatures) in the texture.
EndRem

Local font:T_irrIGUIFont=device.getGUIEnvironment().getBuiltInFont()
Local font2:T_irrIGUIFont=device.getGUIEnvironment().getFont("../media/fonthaettenschweiler.bmp")
Local imp1:T_irrRect_s32=T_irrRect_s32.createFromVals(349,15,385,78)
Local imp2:T_irrRect_s32=T_irrRect_s32.createFromVals(387,15,423,78)

Rem
	Everything is prepared, now we can draw everything in the draw loop,
	between the begin scene And End scene calls. In this example, we 
	are just doing 2d Graphics, but it would be no problem To mix them
	with 3d graphics. Just Try it out, And draw some 3d vertices Or set
	up a scene with the scene manager And draw it.
EndRem

Local time:Int

While(device.run() And driver)

	If (device.isWindowActive())

		time=device.getTimer().getTime()

		driver.beginScene(True,True,T_irrSColor.createFromVals(0,120,102,136))

		Rem
		First, we draw 3 sprites, using the alpha channel we created with
		makeColorKeyTexture. The last parameter specifiys that the drawing
		Method should use thiw alpha channel. The parameter before the last
		one specifies a color, with wich the sprite should be colored.
		(255,255,255,255) is full white, so the sprite will look like the 
		original. The third sprite is drawed colored based on the time.
		EndRem

		' draw fire & dragons background world
		driver.draw2DImageSegment(images,T_irrPosition2d_s32.create(50,50), ..
			T_irrRect_s32.createFromVals(0,0,342,224), Null, ..
			T_irrSColor.createFromVals(255,255,255,255), True)

		If (time/500 Mod 2)
			' draw flying imp 
			driver.draw2DImageSegment(images, T_irrPosition2d_s32.create(164,125), ..
				imp1, Null, T_irrSColor.createFromVals(255,255,255,255),True)
			' draw second flying imp with colorcylce
			driver.draw2DImageSegment(images,T_irrPosition2d_s32.create(270,105), ..
				imp1, Null, ..
				T_irrSColor.createFromVals(255,(time) Mod 255,255,255), True)
		Else
			' draw flying imp 
			driver.draw2DImageSegment(images, T_irrPosition2d_s32.create(164,125), ..
				imp2, Null, T_irrSColor.createFromVals(255,255,255,255),True)
			' draw second flying imp with colorcylce
			driver.draw2DImageSegment(images,T_irrPosition2d_s32.create(270,105), ..
				imp2, Null, ..
				T_irrSColor.createFromVals(255,(time) Mod 255,255,255), True)
		EndIf
	
		Rem
		Drawing text is really simple. The code should be Self explanatory.
		EndRem

		' draw some text
		If (font)
			font.draw("This demo shows that Irrlicht is also capable of drawing 2D graphics.", ..
				T_irrRect_s32.createFromVals(130,10,300,50), ..
				T_irrSColor.createFromVals(255,255,255,255))
		EndIf

		' draw some other text
		If (font2)
			font2.draw("Also mixing with 3d graphics is possible.", ..
				T_irrRect_s32.createFromVals(130,20,300,60), ..
				T_irrSColor.createFromVals(255,time Mod 255,time Mod 255,255))			
		EndIf
		
		Rem
		At last, we draw the Irrlicht Engine logo (without using a color Or
		an alpha channel) And a transparent 2d Rectangle at the position of 
		the mouse cursor.
		EndRem

		' draw logo
		driver.draw2DImageSegment(images,T_irrPosition2d_s32.create(10,10), ..
			T_irrRect_s32.createFromVals(354,87,442,118))

		' draw transparent rect under cursor
		Local m:T_irrPosition2d_s32=device.getCursorControl().getPosition()
		
		driver.draw2DRectangle(T_irrSColor.createFromVals(100,255,255,255), ..
			T_irrRect_s32.createFromVals(m.getX()-20, m.getY()-20, m.getX()+20, m.getY()+20))

		driver.endScene()
	EndIf
Wend

Rem
That's all, it was not really difficult, I hope.
EndRem

device.drop()
